# frozen_string_literal: true

require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/patches', type: :request do
  # This should return the minimal set of attributes required to create a valid
  # Patch. As you add validations to Patch, be sure to
  # adjust the attributes here as well.
  let(:owned_map) { FactoryBot.create :map, user: signed_in_user }
  let(:valid_attributes) do
    resource = FactoryBot.create :resource
    attributes = FactoryBot.build(:patch, map: owned_map).attributes
    attributes['elements'] = [{ resource_id: resource.id }]
    attributes
  end

  let(:invalid_attributes) do
    valid_attributes.merge 'geometry' => 'wrong value'
  end

  # This should return the minimal set of values that should be in the headers
  # in order to pass any filters (e.g. authentication) defined in
  # PatchesController, or in your router and rack
  # middleware. Be sure to keep this updated too.
  let(:valid_headers) do
    {}
  end

  include_context 'with authenticated member'

  describe 'GET /index' do
    it 'renders a successful response' do
      the_patch = FactoryBot.create :patch, map: owned_map
      get api_map_patches_url(the_patch.map_id), headers: valid_headers, as: :json
      expect(response).to be_successful
    end
  end

  describe 'GET /show' do
    it 'renders a successful response' do
      the_patch = FactoryBot.create :patch, map: owned_map
      get api_patch_url(the_patch), as: :json
      expect(response).to be_successful
    end
  end

  describe 'POST /create' do
    context 'with valid parameters' do
      it 'creates a new Patch' do
        expect do
          post api_patches_url, params: valid_attributes, headers: valid_headers, as: :json
        end.to change(Patch, :count).by(1)
      end

      it 'renders an successful response' do
        post api_patches_url, params: valid_attributes, headers: valid_headers, as: :json
        expect(response).to have_http_status(:created)
      end

      it 'render the new patch as JSON' do
        post api_patches_url, params: valid_attributes, headers: valid_headers, as: :json
        expect(response.content_type).to match(a_string_including('application/json'))
      end
    end

    context 'with invalid parameters' do
      it 'does not create a new Patch' do
        expect do
          post api_patches_url, params: { patch: invalid_attributes }, as: :json
        end.not_to change(Patch, :count)
      end

      it 'renders an error response' do
        post api_patches_url, params: { patch: invalid_attributes }, headers: valid_headers, as: :json
        expect(response).to have_http_status(:unprocessable_entity)
      end

      it 'render the error as JSON' do
        post api_patches_url, params: { patch: invalid_attributes }, headers: valid_headers, as: :json
        expect(response.content_type).to eq('application/json; charset=utf-8')
      end
    end
  end

  describe 'PATCH /update' do
    context 'with valid parameters' do
      let(:new_attributes) do
        { name: 'New patch name' }
      end

      it 'updates the requested patch' do
        the_patch = FactoryBot.create :patch, map: owned_map
        patch api_patch_url(the_patch), params: { patch: new_attributes }, headers: valid_headers, as: :json
        the_patch.reload
        expect(the_patch.name).to eq new_attributes[:name]
      end

      it 'renders a JSON response with the patch' do
        the_patch = FactoryBot.create :patch, map: owned_map
        patch api_patch_url(the_patch), params: { patch: new_attributes }, headers: valid_headers, as: :json
        expect(response).to have_http_status(:ok)
      end

      it 'renders the patch as JSON' do
        the_patch = FactoryBot.create :patch, map: owned_map
        patch api_patch_url(the_patch), params: { patch: new_attributes }, headers: valid_headers, as: :json
        expect(response.content_type).to eq('application/json; charset=utf-8')
      end
    end

    context 'with invalid parameters' do
      it 'renders an error response' do
        the_patch = FactoryBot.create :patch, map: owned_map
        patch api_patch_url(the_patch), params: { patch: invalid_attributes }, headers: valid_headers, as: :json
        expect(response).to have_http_status(:unprocessable_entity)
      end

      it 'render the error as JSON' do
        the_patch = FactoryBot.create :patch, map: owned_map
        patch api_patch_url(the_patch), params: { patch: invalid_attributes }, headers: valid_headers, as: :json
        expect(response.content_type).to eq('application/json; charset=utf-8')
      end
    end
  end

  describe 'DELETE /destroy' do
    it 'destroys the requested patch' do
      the_patch = FactoryBot.create :patch, map: owned_map
      expect do
        delete api_patch_url(the_patch), headers: valid_headers, as: :json
      end.to change(Patch, :count).by(-1)
    end
  end
end
